/*----------------------------------------------------------------------*
    smpl10.c
    Tv10 for UD2(Universal Driver II) - Version 1.3
    [XgbvEHb`]
    Copyright (C) 2008 BestTechnology CO.,LTD.
 *----------------------------------------------------------------------*/

/*----------------------------------------------------------------------
 yvOTvz
  nCp[^[~i̒ʐM\tgɐڑĎgp܂B
  ATmega32}CR{[hɒʐMP[u𑕒܂ܓĂB

  dĂ̌oߎԂvĂ^C}gXgbv
  EHb`łB
  2̉{^XCb`ŃX^[gEXgbvEbvvA^[~
  iɌ݂̌vԂ\܂B

  ----------------------------------------------------------------------
 yGCC Developer LiteGCCIvVz
  RpCۂ́ATvvOJAGCCIvV̐ݒ
  Xgujo[ThCo2 (ATmega32)vIuOKvĉB
  ݒ肵IuF9vL[ƃrh(RpC)܂B

  ----------------------------------------------------------------------
 ygpCuz
  Elong UD_ElapsedTimeMotorPower
    vONĂ10msɎIɃJEgAbv܂B
    ʏ͒lǂݍނɂāAlނƂł邾Ă
    B

  ----------------------------------------------------------------------*/

#include  <ud2.h>    // UDwb_t@C

char txb[10], rxb[10];  // Mobt@m

// XgbvEHb`̃Xe[^X
typedef enum {
  S_idle,       // ɂĂ
  S_RealTime,   // vE\
  S_LapTime,    // bv^Cv
  S_Stop        // ~
} StopwatchState;

/*------------------------------------------------------------*/
/* {^[X҂&`^O                        */
/*------------------------------------------------------------*/
typedef int (*pswfunc)(void);

void releasewait (pswfunc func)
{
  wait (1);
  while (func ());
  wait (1);
}

/*------------------------------------------------------------*/
/* ԕ\                                                   */
/*------------------------------------------------------------*/
void disptime(char *cmt, long ms)
{
  int  s, m, h;

  s = (ms / 100) % 60;    // b
  m = (ms / 6000) % 60;   // 
  h = (ms / 36000) % 24;  // 

  rs_printf ("%s%02d:%02d:%02d.%02d\r", cmt, h, m, s, (int)(ms % 100));
}

/*------------------------------------------------------------*/
/* Main Program                                               */
/*------------------------------------------------------------*/
int main(void)
{
  long  now, tim, dead = 0, disp = 0;
  StopwatchState state = S_idle;

  //--------------------------------------
  // ʐM|[g̏
  //--------------------------------------
  rs_init (br115200, txb, sizeof(txb), rxb, sizeof(rxb));

  rs_printf ("\n<SAMPLE 10>\n\n");

  disptime ("TIME = ", 0L);

  //--------------------------------------
  // C[v
  //--------------------------------------
  while (1) {               // [v

    now = GetElapsedTime();   // ŇoߎԂ擾(10msP)

    switch (state) {
      // ɂĂ
      case S_idle:
        if (PushButton1 ()) {
          tim = GetElapsedTime();
          releasewait (PushButton1);
          state = S_RealTime;
        }
        break;
      // vE\
      case S_RealTime:
        disptime ("TIME = ", disp = now - tim + dead);
        if (PushButton1 ()) {
          dead = disp;
          releasewait (&PushButton1);
          state = S_Stop;
          disptime ("STOP = ", disp);
        } else if (PushButton2 ()) {
          releasewait (PushButton2);
          disptime ("LAP  = ", disp);
          state = S_LapTime;
        }
        wait (3);    // 30msEFCg (ʐMf[^ʂ}邽)
        break;
      // bvv
      case S_LapTime:
        if (PushButton1 ()) {
          disptime ("STOP = ", disp = now - tim + dead);
          dead = disp;
          releasewait (PushButton1);
          state = S_Stop;
        } else if (PushButton2 ()) {
          releasewait (PushButton2);
          state = S_RealTime;
        }
        break;
      // ~
      case S_Stop:
        if (PushButton1 ()) {
          tim = GetElapsedTime();
          releasewait (PushButton1);
          state = S_RealTime;
        } else if (PushButton2 ()) {
          releasewait (PushButton2);
          disptime ("TIME = ", 0);
          dead = 0;
          state = S_idle;
        }
        break;
    }
  }
}
